"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPIDs = void 0;
const get_runner_js_1 = require("../../parsers/get-runner.js");
const pid_js_1 = require("../../services/pid.js");
const getPIDsByPorts = (port) => __awaiter(void 0, void 0, void 0, function* () {
    const ports = (0, pid_js_1.setPortsAndPIDs)(port);
    const PIDs = [];
    yield Promise.all(ports.map((p) => __awaiter(void 0, void 0, void 0, function* () {
        PIDs.push(...(yield (get_runner_js_1.isWindows
            ? pid_js_1.getPIDs.windows(p)
            : pid_js_1.getPIDs.unix(p))));
    })));
    return PIDs;
});
const getPIDsByRange = (startsAt, endsAt) => __awaiter(void 0, void 0, void 0, function* () {
    const ports = (0, pid_js_1.populateRange)(startsAt, endsAt);
    return yield (0, exports.getPIDs)(ports);
});
/** Returns an array containing the ID of all processes listening to the specified port */
exports.getPIDs = Object.assign(getPIDsByPorts, {
    /** Returns an array containing the ID of all processes listening to the specified port range */
    range: getPIDsByRange,
});
